
#define MAX_FILENAME_LEN 500	//max length of file names
#define NUM_SIMULT_FILES 10	//max number of files that can be syntax-colored at the same time
#define NUM_UNDO_LEVELS 10

struct change {			//used to represent actions for undo/redo

    gint type;			//0 = insert, 1 = remove
    gint offset;		//offset in chars
    gchar *text;
};

struct openfile {		//used internally to represent open files

    gchar filename[MAX_FILENAME_LEN];	//name of file
    GtkTextBuffer *textbuffer;		//pointer to gtktextbuffer with contents of file
	GtkTextView *textview;			//pointer to gtktextview in tab
	GtkWidget *scrolledtext;	//widget in tab
    struct change *undo_stack[NUM_UNDO_LEVELS];	//undo/redo stack
    gint undo_stack_pos;		//position in undo/redo stack
};

struct status {

    gchar **color_label;		//color names...
    gchar **color_comment;
    gchar **color_directive;
    gchar **output_type;		//output file's extension
    gboolean *usesyncolor;		//syntax coloring flag
    gboolean *usewordwrap;		//word wrap flag
    gboolean *useautoindent;		//automatic indent flag
    gint *tabwidth;			//width of tabs
    GtkWindow *window;			//core widgets
	GtkNotebook *notebook;
	PangoFontDescription **font;	//editor font
    struct openfile **curr_file;	//current open file
    gchar **incdir1;			//include dirs
    gchar **incdir2;
    gchar **incdir3;
};


gchar *get_file_text(struct openfile*);
void add_file(gchar*, gchar*, gint);
gboolean remove_file();
gboolean remove_file_all();
void init_file();
void refresh_tags();
void refresh_tabs();
void refresh_wordwrap();
void assembler_output_clear();
void assembler_output_append(gchar*);
void update_titlebar();
void update_view();
void set_unset_syncolor();
